diff -Naur --exclude=CVS --exclude=configs linux/fs/mfs/ccontact.c linux-openmosix/fs/mfs/ccontact.c
--- linux/fs/mfs/ccontact.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/fs/mfs/ccontact.c	2002-05-31 04:12:18.000000000 +0200
@@ -0,0 +1,325 @@
+/*
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ * Some sections copyright 2002 by Moshe Bar
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * THIS  SOFTWARE  IS  PROVIDED IN ITS  "AS IS"  CONDITION, WITH NO WARRANTY
+ * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
+ * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
+ */
+/*
+ * Author(s): Amnon Shiloh, Moshe Bar
+ */
+
+#include <linux/config.h>
+#ifdef CONFIG_MOSIX_FS
+#include <linux/slab.h>
+#include <linux/mfs.h>
+#include <linux/mfs_socket.h>
+
+spinlock_t mfs_client_lock = SPIN_LOCK_UNLOCKED;
+
+#define MFS_CLIENT_OPTCONS	50
+#define	MFS_MAX_HOGGING_A_NODE	8
+
+struct mfs_client_contact
+{
+	struct mfs_client_contact *next;
+	int to;
+	struct socket *sock;
+	int serial;
+	int has_mh;
+	struct mfs_message_header mh;
+} *mfs_busy_clients, *mfs_connected_clients, *mfs_closing_clients;
+
+int mfs_client_serial;
+
+DECLARE_WAIT_QUEUE_HEAD(wait_for_busy_contact);
+int waiting_for_busy_contact;
+
+int
+mfs_client_send(struct mfs_client_contact *s, int type, void *header, int hdln,
+			void *dat1, int len1, void *dat2, int len2)
+{
+	return(mfs_send(s->sock, 0, s->serial,
+				type, header, hdln, dat1, len1, dat2, len2));
+}
+
+int
+mfs_client_receive(struct mfs_client_contact *s,
+					void **header, void **dat1, void **dat2)
+{
+	if(s->has_mh)
+	{
+		s->has_mh = 0;
+if(mfs_debug > 1)
+printk("mfs_client_receive: continuing with serial %d, type %d (%d/%d/%d)\n",
+s->mh.serial, s->mh.type, s->mh.hdsz, s->mh.dat1sz, s->mh.dat2sz);
+		return(mfs_receive(s->sock, MFS_MUST_MATCH, &s->serial, &s->mh,
+							header, dat1, dat2));
+	}
+	else
+		return(mfs_receive(s->sock, MFS_SKIP_OTHERS, &s->serial, NULL,
+							header, dat1, dat2));
+}
+
+int
+mfs_client_contact_has_data(struct mfs_client_contact *con)
+{
+	return(mfs_socket_has_data(con->sock));
+}
+
+void
+delayed_close_client(struct mfs_client_contact *con)
+{
+	mfs_send(con->sock, 1, 0, MFS_CLOSE, NULL, 0, NULL, 0, NULL,0);
+	spin_lock(&mfs_client_lock);
+	con->next = mfs_closing_clients;
+	mfs_closing_clients = con;
+	spin_unlock(&mfs_client_lock);
+}
+
+void
+mfs_client_check_closed(struct mfs_client_contact **head)
+{
+	struct mfs_client_contact *c, *prev, *next;
+	struct mfs_client_contact *dispose = NULL;
+
+	spin_lock(&mfs_client_lock);
+	for(prev = NULL, c = *head ; c ; c = next)
+	{
+		next = c->next;
+		if(mfs_socket_is_closed(c->sock))
+		{
+			if(prev)
+				prev->next = next;
+			else
+				*head = next;
+			c->next = dispose;
+			dispose = c;
+		}
+		else
+			prev = c;
+	}
+	spin_unlock(&mfs_client_lock);
+	for(; dispose ; dispose = next)
+	{
+		next = dispose->next;
+		mfs_close_socket(dispose->sock);
+		kfree(dispose);
+	}
+}
+
+void
+mfs_release_contact(struct mfs_client_contact *con)
+{
+	struct mfs_client_contact *s, *prev;
+	unsigned int bcnt = 0, pcnt = 0, tcnt = 0;
+	int pe = con->to;
+	unsigned int found = 0;
+
+	spin_lock(&mfs_client_lock);
+	for(prev = NULL , s = mfs_busy_clients ; s ; )
+	{
+		tcnt++;
+		if(s == con)
+		{
+			s = s->next;
+			if(prev)
+				prev->next = s;
+			else
+				mfs_busy_clients = s;
+			found = 1;
+		}
+		else
+		{
+			if(s->to == pe && ++bcnt >= MFS_MAX_HOGGING_A_NODE &&
+									found)
+				break;
+			prev = s;
+			s = s->next;
+		}
+	}
+	if(!found)
+		printk("mfs_release_contact: not listed!\n");
+	if((pcnt = bcnt) < MFS_MAX_HOGGING_A_NODE)
+	for(s = mfs_connected_clients ; s ; s = s->next)
+	{
+		tcnt++;
+		if(s->to == pe && ++pcnt == MFS_MAX_HOGGING_A_NODE)
+			break;
+	}
+	if((tcnt >= MFS_CLIENT_OPTCONS && pcnt) ||
+						pcnt >= MFS_MAX_HOGGING_A_NODE)
+	{
+		spin_unlock(&mfs_client_lock);
+		delayed_close_client(con);
+		if(bcnt >= MFS_MAX_HOGGING_A_NODE)
+			return;
+		spin_lock(&mfs_client_lock);
+	}
+	else
+	{
+		con->next = mfs_connected_clients;
+		mfs_connected_clients = con;
+	}
+	if(waiting_for_busy_contact == pe ||
+		waiting_for_busy_contact == MFS_UNKNOWN_PE)
+	{
+		waiting_for_busy_contact = 0;
+		wake_up(&wait_for_busy_contact);
+	}
+	spin_unlock(&mfs_client_lock);
+}
+
+static inline int
+node_is_hogged(int pe)
+{
+	unsigned int n = 0;
+	struct mfs_client_contact *s;
+
+	for(s = mfs_busy_clients ; s ; s = s->next)
+	if(s->to == pe && ++n == MFS_MAX_HOGGING_A_NODE)
+		return(1);
+	return(0);
+}
+
+struct mfs_client_contact *
+mfs_new_request(int pe, int type, void *header, int hdln, void *dat1, int len1,
+							void *dat2, int len2)
+{
+	struct mfs_client_contact *s, *prev, *prevprev, *con;
+	unsigned int tried_a_new = 0;
+	unsigned int cnt;
+	DECLARE_WAITQUEUE(wait, current);
+
+	if(pe == MFS_BAD_PE)
+		return(ERR_PTR(-ESTALE));
+	spin_lock(&mfs_client_lock);
+	for(prev = prevprev = NULL , cnt = 0 , s = mfs_connected_clients ; s ;
+					prevprev = prev, prev = s , s = s->next)
+	if(s->to == pe)
+		break;
+	else
+		cnt++;
+	if(s)
+	{
+		found_a_connected:
+		if(prev)
+			prev->next = s->next;
+		else
+			mfs_connected_clients = s->next;
+		try_it:
+		con = s;
+		con->to = pe;
+		con->next = mfs_busy_clients;
+		mfs_busy_clients = con;
+		con->serial = ++mfs_client_serial;
+		spin_unlock(&mfs_client_lock);
+		if(!mfs_send(con->sock, 1, con->serial, type, header, hdln,
+						dat1, len1, dat2, len2) &&
+			mfs_receive(con->sock, MFS_JUST_HEADER, &con->serial,
+					&con->mh, NULL, NULL, NULL) >= 0)
+		{
+			con->has_mh = 1;
+if(mfs_debug > 1)
+printk("mfs_new_request: first reply will be serial %d, type %d (%d/%d/%d)\n",
+con->mh.serial, con->mh.type, con->mh.hdsz, con->mh.dat1sz, con->mh.dat2sz);
+			return(con);
+		}
+		spin_lock(&mfs_client_lock);
+		for(prev = NULL , s = mfs_busy_clients ; s && s != con ;
+							prev = s , s = s->next)
+			;
+		if(s)
+		{
+			if(prev)
+				prev->next = s->next;
+			else
+				mfs_busy_clients = s->next;
+			if(waiting_for_busy_contact == pe ||
+				waiting_for_busy_contact == MFS_UNKNOWN_PE)
+			{
+				waiting_for_busy_contact = 0;
+				wake_up(&wait_for_busy_contact);
+			}
+			spin_unlock(&mfs_client_lock);
+			mfs_close_socket(s->sock);
+			kfree(s);
+			spin_lock(&mfs_client_lock);
+		}
+		else
+			printk("mfs_new_request: contact disappeared!\n");
+	}
+	else if(cnt >= MFS_CLIENT_OPTCONS)
+	{
+		/* trim out the last one (also last used) */
+		prevprev->next = NULL;
+		spin_unlock(&mfs_client_lock);
+		delayed_close_client(prev);
+		mfs_client_check_closed(&mfs_closing_clients);
+		spin_lock(&mfs_client_lock);
+	}
+	if(tried_a_new || !PE)
+	{
+		spin_unlock(&mfs_client_lock);
+		return(ERR_PTR(-EREMOTE));
+	}
+	if(node_is_hogged(pe))
+	{
+		add_wait_queue(&wait_for_busy_contact, &wait);
+		while(1)
+		{
+			set_current_state(TASK_UNINTERRUPTIBLE);
+			if(waiting_for_busy_contact &&
+				waiting_for_busy_contact != pe)
+				waiting_for_busy_contact = MFS_UNKNOWN_PE;
+			else
+				waiting_for_busy_contact = pe;
+			if(!node_is_hogged(pe))
+				break;
+			spin_unlock(&mfs_client_lock);
+			if(!PE)
+			{
+				remove_wait_queue(&wait_for_busy_contact, &wait);
+				set_current_state(TASK_RUNNING);
+				return(NULL);
+			}
+			schedule_timeout(HZ);
+			spin_lock(&mfs_client_lock);
+			for(prev = NULL , s = mfs_connected_clients ; s ;
+							prev = s , s = s->next)
+			if(s->to == pe)
+			{
+				remove_wait_queue(&wait_for_busy_contact,&wait);
+				set_current_state(TASK_RUNNING);
+				goto found_a_connected;
+			}
+		}
+		remove_wait_queue(&wait_for_busy_contact, &wait);
+		set_current_state(TASK_RUNNING);
+	}
+	spin_unlock(&mfs_client_lock);
+	tried_a_new++;
+	if(!(s = (struct mfs_client_contact *)kmalloc(sizeof(*s), GFP_KERNEL)))
+		return(ERR_PTR(-ENOMEM));
+	s->sock = mfs_connect_to(pe);
+	s->has_mh = 0;
+	if(!IS_ERR(s->sock))
+	{
+		spin_lock(&mfs_client_lock);
+		goto try_it;
+	}
+	con = (struct mfs_client_contact *)s->sock;
+	kfree(s);
+	return(con);
+}
+
+void
+mfs_monitor_client_contacts(void)
+{
+	mfs_client_check_closed(&mfs_connected_clients);
+	mfs_client_check_closed(&mfs_closing_clients);
+}
+#endif /* CONFIG_MOSIX_FS */
diff -Naur --exclude=CVS --exclude=configs linux/fs/mfs/client.c linux-openmosix/fs/mfs/client.c
--- linux/fs/mfs/client.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/fs/mfs/client.c	2003-12-02 10:59:37.000000000 +0100
@@ -0,0 +1,761 @@
+/* All changes since Feb 12, 2002 by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ * Some sections copyright 2002 by Moshe Bar
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Amnon Shiloh, Moshe Bar
+ */
+
+#include <linux/sched.h>
+#ifdef CONFIG_MOSIX_FS
+#include <asm/uaccess.h>
+#include <linux/slab.h>
+#include <linux/mfs.h>
+
+void
+pack_credits(struct mfs_cred *cred)
+{
+	register struct task_struct *p = current;
+	register int i;
+
+	cred->uid = p->uid;
+	cred->euid = p->euid;
+	cred->sgid = p->sgid;
+	cred->fsuid = p->fsuid;
+	cred->gid = p->gid;
+	cred->egid = p->egid;
+	cred->sgid = p->sgid;
+	cred->fsgid = p->fsgid;
+	cred->ngroups = p->ngroups;
+	for(i = cred->ngroups-1 ; i >= 0 ; i--)
+		cred->groups[i] = p->groups[i];
+	cred->caps = p->cap_effective;
+	cred->whereami = current->mosix.whereami ? : PE;
+	cred->deppe = current->mosix.deppe ? : PE;
+}
+
+/* originally by Amnon Shiloh with changes by Moshe Bar*/
+int
+mfs_client_statfs(int pe, mfs_handle_t handle, struct statfs *statbuf)
+{
+        struct mfs_request_statfs s;
+        struct mfs_reply_statfs *r;
+        struct mfs_client_contact *con;
+	int err;
+	pack_credits(&s.cred);
+	s.handle = handle;
+	con = mfs_new_request(pe, MFS_REQUEST_STATFS, &s, sizeof(s), NULL, 0,NULL, 0);
+	if(IS_ERR(con))
+		return((int)con);
+	err = mfs_client_receive(con, (void **)&r, NULL, NULL);
+	if(err == MFS_REPLY_STATFS)
+	{
+		err = r->result;
+		if(err >= 0)
+		*statbuf = r->stat;
+	}
+	else if(err >= 0)
+	{
+	printk("openMosix: mfs_client_statfs: ambiguous reply %d\n", err);
+	err = -EINVAL;
+	}
+	if(r)
+	 kfree(r);
+	mfs_release_contact(con);
+	return(err);
+}
+
+inline void
+mfs_file_up_to_date(struct file *filp)
+{
+	struct dentry *dp;
+	struct mfs_dinfo *i;
+
+	if((dp = filp->f_dentry) && (i = (struct mfs_dinfo *)dp->d_fsdata))
+		i->latest = jiffies;
+}
+
+int
+mfs_client_attach_handle(int pe, mfs_handle_t handle)
+{
+	struct mfs_request_attach_handle s;
+	struct mfs_reply_attach_handle *r;
+	struct mfs_client_contact *con;
+	int err;
+
+	s.handle = handle;
+	con = mfs_new_request(pe, MFS_REQUEST_ATTACH_HANDLE, &s, sizeof(s),
+							NULL, 0, NULL, 0);
+	if(IS_ERR(con))
+		return((int)con);
+	err = mfs_client_receive(con, (void **)&r, NULL, NULL);
+	if(err == MFS_REPLY_ATTACH_HANDLE)
+		err = r->result;
+	else if(err >= 0)
+	{
+		printk("mfs_client_attach_handle: unexpected reply %d\n", err);
+		err = -EINVAL;
+	}
+	if(r)
+		kfree(r);
+	mfs_release_contact(con);
+	return(err);
+}
+
+int
+mfs_client_touch_handle(int pe, mfs_handle_t handle)
+{
+	struct mfs_request_touch_handle s;
+	struct mfs_reply_touch_handle *r;
+	struct mfs_client_contact *con;
+	int err;
+
+	s.handle = handle;
+	con = mfs_new_request(pe, MFS_REQUEST_TOUCH_HANDLE, &s, sizeof(s),
+							NULL, 0, NULL, 0);
+	if(IS_ERR(con))
+		return((int)con);
+	err = mfs_client_receive(con, (void **)&r, NULL, NULL);
+	if(err == MFS_REPLY_TOUCH_HANDLE)
+		err = r->result;
+	else if(err >= 0)
+	{
+		printk("mfs_client_touch_handle: unexpected reply %d\n", err);
+		err = -EINVAL;
+	}
+	if(r)
+		kfree(r);
+	mfs_release_contact(con);
+	return(err);
+}
+
+void
+mfs_client_dispose_handle(int pe, mfs_handle_t handle)
+{
+	struct mfs_request_dispose_handle s;
+	struct mfs_client_contact *con;
+	void *r;
+
+	s.handle = handle;
+	con = mfs_new_request(pe, MFS_REQUEST_DISPOSE_HANDLE, &s, sizeof(s),
+							NULL, 0, NULL, 0);
+	if(IS_ERR(con))
+		return;
+	mfs_client_receive(con, &r, NULL, NULL);
+	if(r)
+		kfree(r);
+	mfs_release_contact(con);
+}
+
+int
+mfs_client_llseek(int pe, mfs_handle_t handle, struct file *filp, loff_t offset,
+								int origin)
+{
+	struct mfs_request_llseek s;
+	struct mfs_reply_llseek *r;
+	struct mfs_client_contact *con;
+	int err;
+
+	pack_credits(&s.cred);
+	s.handle = handle;
+	s.file = *filp;
+	s.offset = offset;
+	s.origin = origin;
+	con = mfs_new_request(pe, MFS_REQUEST_LLSEEK, &s, sizeof(s), NULL, 0,
+								NULL, 0);
+	if(IS_ERR(con))
+		return((int)con);
+	err = mfs_client_receive(con, (void **)&r, NULL, NULL);
+	if(err == MFS_REPLY_LLSEEK)
+	{
+		cp_file_fields(filp, &r->file);
+		err = r->result;
+		if(err >= 0)
+			mfs_file_up_to_date(filp);
+	}
+	else if(err >= 0)
+	{
+		printk("mfs_client_llseek: unexpected reply %d\n", err);
+		err = -EINVAL;
+	}
+	if(r)
+		kfree(r);
+	mfs_release_contact(con);
+	return(err);
+}
+
+ssize_t
+mfs_client_read(int pe, mfs_handle_t handle, struct file *filp, char *buf,
+						size_t count, loff_t *ppos)
+{
+	struct mfs_request_read s;
+	struct mfs_reply_read *r;
+	struct mfs_client_contact *con;
+	void *data;
+	int err;
+	ssize_t i, result = 0;
+	int user_err = 0;
+	unsigned int done = 0;
+
+	if((int)count < 0)
+		return(-EINVAL);
+	pack_credits(&s.cred);
+	s.handle = handle;
+	s.file = *filp;
+	s.count = count;
+	s.pos = *ppos;
+	con = mfs_new_request(pe, MFS_REQUEST_READ, &s, sizeof(s), NULL, 0,
+								NULL, 0);
+	if(IS_ERR(con))
+		return((int)con);
+	while(!done)
+	{
+		err = mfs_client_receive(con, (void **)&r, &data, NULL);
+		if(err < 0)
+		{
+			result = err;
+			break;
+		}
+		switch(err)
+		{
+			case MFS_INTERIM_DATA:
+				i = ((struct mfs_interim_data *)r)->count;
+				if(!user_err && copy_to_user(buf, data, i))
+					user_err = -EFAULT;
+				else
+					buf += i;
+				/* do not exit: it is always the server
+				 * that should close the connection
+				 */
+				break;
+			case MFS_REPLY_READ:
+				done = 1;
+				if(!user_err && r->datalen &&
+					copy_to_user(buf, data, r->datalen))
+					user_err = -EFAULT;
+				cp_file_fields(filp, &r->file);
+				*ppos = r->ppos;
+				result = r->result;
+				if(result >= 0)
+					mfs_file_up_to_date(filp);
+				break;
+			default:
+				printk("mfs_client_read: unexpected reply %d\n",
+									err);
+				result = -EINVAL;
+				done = 1;
+				break;
+				
+		}
+		if(r)
+			kfree(r);
+	}
+	mfs_release_contact(con);
+	return(user_err ? : result);
+}
+
+ssize_t
+mfs_client_write(int pe, mfs_handle_t handle, struct file *filp, char *buf,
+					size_t count, loff_t *ppos, long flim)
+{
+	struct mfs_request_write s;
+	struct mfs_interim_data i;
+	struct mfs_reply_write *r;
+	struct mfs_client_contact *con;
+	void *data;
+	int err;
+	ssize_t result = 0;
+	int user_err = 0;
+	size_t max, sent, cnt;
+	char smallbuf[4];
+	char *tbuf = NULL;	/* NULL just because bad compiler complains */
+
+	if(count == 0)
+		return(0);
+	if((int)count < 0)
+		return(-EINVAL);
+	pack_credits(&s.cred);
+	s.handle = handle;
+	s.file = *filp;
+	s.count = count;
+	s.pos = *ppos;
+	s.flim = flim;
+	for(max = count > 16384 ? 16384 : count ; max > sizeof(smallbuf) ;
+								max >>= 1)
+	if((tbuf = (char *)kmalloc(max, GFP_KERNEL)))
+		break;
+	if(max <= sizeof(smallbuf))
+	{
+		tbuf = smallbuf;
+		max = sizeof(smallbuf);
+	}
+	s.datalen = sent = count < max ? count : max;
+	if(copy_from_user(tbuf, buf, sent))
+	{
+		user_err = -EFAULT;
+		goto free_buf;
+	}
+	buf += sent;
+	con = mfs_new_request(pe, MFS_REQUEST_WRITE, &s, sizeof(s), tbuf, sent,
+								NULL, 0);
+	if(IS_ERR(con))
+	{
+		result = (int)con;
+		goto free_buf;
+	}
+	while(sent < count)
+	{
+		if(mfs_client_contact_has_data(con))
+			break;
+		cnt = count - sent;
+		if(cnt > max)
+			cnt = max;
+		if(user_err || copy_from_user(tbuf, buf, cnt))
+		{
+			user_err = -EFAULT;
+			mfs_client_send(con, MFS_STOP, NULL, 0,
+					NULL, 0, NULL, 0);
+			break;	/* let the server quit first */
+		}
+		i.count = cnt;
+		if((err = mfs_client_send(con, MFS_INTERIM_DATA,
+			&i, sizeof(i), (void *)tbuf, cnt,
+			NULL, 0)))
+		{
+			result = err;
+			break;
+		}
+		buf += cnt;
+		sent += cnt;
+	}
+	err = mfs_client_receive(con, (void **)&r, &data, NULL);
+	if(err == MFS_CONTINUE)
+		err = mfs_client_receive(con, (void **)&r, &data, NULL);
+	if(err == MFS_REPLY_WRITE)
+	{
+		cp_file_fields(filp, &r->file);
+		*ppos = r->ppos;
+		result = r->result;
+		if(result >= 0)
+			mfs_file_up_to_date(filp);
+		if(r->hadsigxfsz)
+			send_sig(SIGXFSZ, current, 0);
+	}
+	else if(err < 0)
+		result = err;
+	else
+	{
+		printk("mfs_client_write: unexpected reply %d\n", err);
+		result = -EINVAL;
+	}
+	if(r)
+		kfree(r);
+	mfs_release_contact(con);
+	free_buf:
+	if(max != sizeof(smallbuf))
+		kfree(tbuf);
+	return(user_err ? : result);
+}
+
+int
+mfs_client_readdir_transfer(void *d, int len, void *dirent, filldir_t filldir)
+{
+	ino_t ino;
+	loff_t off;
+	unsigned int type;
+	short namelen;
+	int err;
+
+	while(len)
+	{
+		len -= sizeof(ino)+sizeof(off)+sizeof(type)+sizeof(namelen);
+		if(len < 0)
+			return(-EINVAL);
+		ino = *((ino_t *)d)++;
+		off = *((loff_t *)d)++;
+		type = *((unsigned int *)d)++;
+		namelen = *((short *)d)++;
+		if(len < namelen)
+			return(-EINVAL);
+		len -= namelen;
+		if((err = filldir(dirent, (const char *)d, namelen, off, ino,
+									type)))
+			return(err);
+		d += namelen;
+	}
+	return(0);
+}
+
+int
+mfs_client_readdir(int pe, mfs_handle_t handle, struct file *filp, void *dirent,
+	filldir_t filldir, int policy, int maxbytes, int *packets, int *bytes)
+{
+	struct mfs_request_readdir s;
+	struct mfs_reply_readdir *r;
+	struct mfs_interim_readdir ri;
+	struct mfs_client_contact *con;
+	void *data;
+	ssize_t i;
+	int result = 0;
+	unsigned int done = 0;
+
+	pack_credits(&s.cred);
+	s.handle = handle;
+	s.file = *filp;
+	s.policy = policy;
+	s.maxbytes = maxbytes;
+	*packets = *bytes = 0;
+	con = mfs_new_request(pe, MFS_REQUEST_READDIR, &s, sizeof(s), NULL, 0,
+								NULL, 0);
+	if(IS_ERR(con))
+		return((int)con);
+	while(!done && (result =
+		mfs_client_receive(con, (void **)&r, &data, NULL)) >= 0)
+	{
+		switch(result)
+		{
+			case MFS_INTERIM_DATA:
+				i = ((struct mfs_interim_data *)r)->count;
+				(*packets)++;
+				(*bytes) += i;
+				ri.error = mfs_client_readdir_transfer(data, i,
+							dirent, filldir);
+				if((result = mfs_client_send(con,
+					MFS_INTERIM_READDIR, &ri, sizeof(ri),
+					NULL, 0, NULL, 0)))
+					done = 1;
+				break;
+			case MFS_REPLY_READDIR:
+				done = 1;
+				(*bytes) += r->datalen;
+				if(!r->datalen ||
+					!(result = mfs_client_readdir_transfer(
+					data, r->datalen, dirent, filldir)))
+					result = r->result;
+				cp_file_fields(filp, &r->file);
+				if(result >= 0)
+					mfs_file_up_to_date(filp);
+				break;
+			default:
+				printk("mfs_client_readdir: unexpected reply %d\n", result);
+				result = -EINVAL;
+				done = 1;
+				break;
+		}
+		if(r)
+			kfree(r);
+	}
+	mfs_release_contact(con);
+	return(result);
+}
+
+int
+mfs_client_ioctl(int pe, mfs_handle_t handle, struct file *filp,
+		unsigned int cmd, unsigned long arg, int size, int *data)
+{
+	struct mfs_request_ioctl s;
+	struct mfs_reply_ioctl *r;
+	struct mfs_client_contact *con;
+	int err;
+
+	pack_credits(&s.cred);
+	s.handle = handle;
+	s.file = *filp;
+	s.cmd = cmd;
+	s.arg = arg;
+	s.data = *data;
+	s.size = size;
+	con = mfs_new_request(pe, MFS_REQUEST_IOCTL, &s, sizeof(s), NULL, 0,
+								NULL, 0);
+	if(IS_ERR(con))
+		return((int)con);
+	err = mfs_client_receive(con, (void **)&r, NULL, NULL);
+	if(err == MFS_REPLY_IOCTL)
+	{
+		cp_file_fields(filp, &r->file);
+		if(size < 0)
+			*data = r->data;
+		err = r->result;
+		if(err >= 0)
+			mfs_file_up_to_date(filp);
+	}
+	else if(err >= 0)
+	{
+		printk("mfs_client_ioctl: unexpected reply %d\n", err);
+		err = -EINVAL;
+	}
+	if(r)
+		kfree(r);
+	mfs_release_contact(con);
+	return(err);
+}
+
+int
+mfs_client_fsync(int pe, mfs_handle_t handle, struct file *filp, int datasync)
+{
+	struct mfs_request_fsync s;
+	struct mfs_reply_fsync *r;
+	struct mfs_client_contact *con;
+	int err;
+
+	pack_credits(&s.cred);
+	s.handle = handle;
+	s.file = *filp;
+	s.datasync = datasync;
+	con = mfs_new_request(pe, MFS_REQUEST_FSYNC, &s, sizeof(s), NULL, 0,
+								NULL, 0);
+	if(IS_ERR(con))
+		return((int)con);
+	err = mfs_client_receive(con, (void **)&r, NULL, NULL);
+	if(err == MFS_REPLY_FSYNC)
+	{
+		cp_file_fields(filp, &r->file);
+		err = r->result;
+		if(err >= 0)
+			mfs_file_up_to_date(filp);
+	}
+	else if(err >= 0)
+	{
+		printk("mfs_client_fsync: unexpected reply %d\n", err);
+		err = -EINVAL;
+	}
+	if(r)
+		kfree(r);
+	mfs_release_contact(con);
+	return(err);
+}
+
+int
+mfs_client_open(int pe, mfs_handle_t handle, struct inode *inode, struct file *filp)
+{
+	struct mfs_client_contact *con;
+	struct mfs_request_open s;
+	struct mfs_reply_open *r;
+	int ret;
+
+	pack_credits(&s.cred);
+	s.handle = handle;
+	s.file = *filp;
+	s.inode = *inode;
+	con = mfs_new_request(pe, MFS_REQUEST_OPEN, &s, sizeof(s), NULL, 0,
+								NULL, 0);
+	if (IS_ERR(con))
+		return ((int) con);
+
+	ret = mfs_client_receive(con, (void **) &r, 0, 0);
+	switch (ret)
+	{
+		case MFS_REPLY_OPEN:
+			cp_file_fields(filp, &r->file);
+			ret = r->result;
+			if (ret >= 0)
+				mfs_file_up_to_date(filp);
+			break;
+		default:
+			printk("mfs_client_open: unexpected reply %d\n", ret);
+			ret = -EINVAL;
+			break;
+	}
+	mfs_release_contact(con);
+	return ret;
+}
+
+int
+mfs_client_close(int pe, mfs_handle_t handle, struct inode *inode, struct file *filp)
+{
+	struct mfs_client_contact *con;
+	struct mfs_request_open s;
+	struct mfs_reply_open *r;
+	int ret;
+
+	pack_credits(&s.cred);
+	s.handle = handle;
+	s.file = *filp;
+	s.inode = *inode;
+	con = mfs_new_request(pe, MFS_REQUEST_CLOSE, &s, sizeof(s), NULL, 0,
+								NULL, 0);
+	if (IS_ERR(con))
+		return ((int) con);
+
+	ret = mfs_client_receive(con, (void **) &r, 0, 0);
+	switch (ret)
+	{
+		case MFS_REPLY_CLOSE:
+			cp_file_fields(filp, &r->file);
+			ret = r->result;
+			if (ret >= 0)
+				mfs_file_up_to_date(filp);
+			break;
+		default:
+			printk("mfs_client_closedir: unexpected reply %d\n", ret);
+			ret = -EINVAL;
+			break;
+	}
+	mfs_release_contact(con);
+	return ret;
+}
+
+int
+mfs_client_revalidate(int pe, mfs_handle_t handle, struct subinode *iinfo)
+{
+	struct mfs_request_revalidate s;
+	struct mfs_reply_revalidate *r;
+	struct mfs_client_contact *con;
+	int err;
+
+	pack_credits(&s.cred);
+	s.handle = handle;
+	con = mfs_new_request(pe, MFS_REQUEST_REVALIDATE, &s, sizeof(s),
+							NULL, 0, NULL, 0);
+	if(IS_ERR(con))
+		return((int)con);
+	err = mfs_client_receive(con, (void **)&r, NULL, NULL);
+	if(err == MFS_REPLY_REVALIDATE)
+	{
+		*iinfo = r->iinfo;
+		err = r->result;
+	}
+	else if(err >= 0)
+	{
+		printk("mfs_client_revalidate: unexpected reply %d\n", err);
+		err = -EINVAL;
+	}
+	if(r)
+		kfree(r);
+	mfs_release_contact(con);
+	return(err);
+}
+
+int
+mfs_client_express_lookup(int pe, mfs_handle_t *handle, char *name,
+	unsigned int follow, struct subinode *iinfo, char **newname,
+	struct mfs_completion *complete)
+{
+	struct mfs_request_express s;
+	struct mfs_reply_express *r;
+	struct mfs_client_contact *con;
+	int err;
+	void *name_back, *more_data;
+
+	*newname = NULL;
+	pack_credits(&s.cred);
+	s.handle = *handle;
+	s.namelen = strlen(name) + 1;
+	s.follow = follow;
+	s.link_count = current->link_count;
+	s.total_link_count = current->total_link_count;
+	s.complete = *complete;
+	con = mfs_new_request(pe, MFS_REQUEST_EXPRESS, &s, sizeof(s),
+				(void *)name, s.namelen,
+				s.complete.more_data, s.complete.more_data_len);
+	if(IS_ERR(con))
+		return((int)con);
+	err = mfs_client_receive(con, (void **)&r, &name_back, &more_data);
+	if(err == MFS_REPLY_EXPRESS)
+	{
+		*handle = r->handle;
+		*iinfo = r->iinfo;
+		*complete = r->complete;
+		err = r->result;
+		if(!err)
+		{
+			if(!r->namelen)
+				*newname = NULL;
+			else if((*newname = kmalloc(r->namelen, GFP_KERNEL)))
+				memcpy(*newname, name_back, r->namelen);
+			else
+				err = -ENOMEM;
+		}
+		if(complete->more_data)
+		{
+			if((complete->more_data =
+				kmalloc(complete->more_data_len, GFP_KERNEL)))
+				memcpy(complete->more_data, more_data,
+						complete->more_data_len);
+			else
+			{
+				if(!err)
+					err = -ENOMEM;
+				if(*newname)
+				{
+					kfree(*newname);
+					*newname = NULL;
+				}
+			}
+		}
+	}
+	else if(err >= 0)
+	{
+		printk("mfs_client_express_lookup: unexpected reply %d\n", err);
+		err = -EINVAL;
+	}
+	if(r)
+		kfree(r);
+	mfs_release_contact(con);
+	return(err);
+}
+
+char *
+mfs_client_check_path(int pe, mfs_handle_t handle)
+{
+	struct mfs_request_checkpath s;
+	struct mfs_reply_checkpath *r;
+	char *path;
+	char *copy = NULL;
+	struct mfs_client_contact *con;
+	int err;
+
+	pack_credits(&s.cred);
+	s.handle = handle;
+	con = mfs_new_request(pe, MFS_REQUEST_CHECKPATH, &s, sizeof(s), NULL, 0,
+								NULL, 0);
+	if(IS_ERR(con))
+		return(NULL);
+	err = mfs_client_receive(con, (void **)&r, (void *)&path, NULL);
+	if(err == MFS_REPLY_CHECKPATH)
+	{
+		if(r->namelen && (copy = kmalloc(r->namelen, GFP_KERNEL)))
+			memcpy(copy, path, r->namelen);
+	}
+	else if(err >= 0)
+	{
+		printk("mfs_client_check_path: unexpected reply %d\n", err);
+		err = -EINVAL;
+	}
+	if(r)
+		kfree(r);
+	mfs_release_contact(con);
+	return(copy);
+}
+
+int
+mfs_client_setattr(int pe, mfs_handle_t handle, struct iattr *iattr)
+{
+	struct mfs_request_setattr s;
+	struct mfs_reply_setattr *r;
+	struct mfs_client_contact *con;
+	int err;
+
+	pack_credits(&s.cred);
+	s.handle = handle;
+	s.attr = *iattr;
+	con = mfs_new_request(pe, MFS_REQUEST_SETATTR, &s, sizeof(s),
+							NULL, 0, NULL, 0);
+	if(IS_ERR(con))
+		return((int)con);
+	err = mfs_client_receive(con, (void **)&r, NULL, NULL);
+	if(err == MFS_REPLY_SETATTR)
+		err = r->result;
+	else if(err >= 0)
+	{
+		printk("mfs_client_setattr: unexpected reply %d\n", err);
+		err = -EINVAL;
+	}
+	if(r)
+		kfree(r);
+	mfs_release_contact(con);
+	return(err);
+}
+
+#endif /* CONFIG_MOSIX_FS */
